//#define SAVE_SCREEN				// this directive forces saving/restoring the screen

// produce all types of files
#define USE_TI89				// 89
#define USE_TI92PLUS			// 92+
#define USE_V200				// voyage 200

#include <stdio.h>				// standard ANSI C input/output support
#include <kbd.h>				// keyboard handling support, needed for ngetchx
#include <tigcclib.h>			// include all headers
#include "data & functions.h"
#include "titlescreen.h"
#include "background.h"

void _main(void)							// main entrie point of program
{
int oldscore;
int foo = 9999;
FILE *catchhsc;

// obtain the location of the file
//SYM_ENTRY *sym=SymFindPtr(SYMSTR("catchhsc"),0);
//HANDLE h=sym->handle;

/////////////////////////////// read file "catcghsc" ///////////////////////////////////
/**/				SYM_ENTRY *sym=SymFindPtr(SYMSTR("catchhsc"),0);				/**/
/**/				HANDLE h=sym->handle;											/**/
/**/				void *ptr=HeapDeref(h);											/**/
/**/				if (!(oldscore=*(int*)(ptr+2))) /*handle error*/;				/**/
////////////////////////////////////////////////////////////////////////////////////////
if (oldscore < 1 || oldscore > 9999)
	{
	if(!(sym->flags.bits.archived))		
		{
		FILE *fp = fopen ("catchhsc", "wb");
		fwrite(&foo,sizeof(int),1,fp);
		fputc (0, fp);
		fputs ("hisc", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
		oldscore = foo;
		}
	}

void *scrBuf=malloc(LCD_SIZE);
LCD_save(scrBuf);
randomize();

INT_HANDLER save_int_1;
save_int_1 = GetIntVec (AUTO_INT_1);
SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
INT_HANDLER save_int_5;
save_int_5 = GetIntVec (AUTO_INT_5);
SetIntVec (AUTO_INT_5, DUMMY_HANDLER);
if (!GrayOn())
{SetIntVec (AUTO_INT_1, save_int_1);
SetIntVec (AUTO_INT_1, save_int_5);
LCD_restore(scrBuf);
free(scrBuf);
ST_helpMsg("GRAY FAILED!!!!!!!");
return;}

int x,y,quit,gx,gy,guy,change,lr,key,time,loop2,loop3,ext,select,loop;
x = random(144);
y = random(68);
gx = random(140)+4;
gy = random(60)+4;
change = guy = 1;
lr = 1;
time = 1;
ext = 0;
float caught = 0;
select = 11;
int dificulty = 4;
int start = 0;
//int trp = 0, trpx, trpy;
int jump = 100;
int snag = 0;

if (sym->flags.bits.archived)
	{
	clear_gray_screen();
	FontSetSys (F_8x10);	
	printf_xy (30,1,"**WARNING**");
	FontSetSys (F_6x8);
	printf_xy (0,20,"I won't be able to save");
	printf_xy (0,30,"please unarchive catchhsc");
	while (!_keytest(RR_ENTER) && !_keytest(RR_2ND) && !_keytest(RR_ESC)){};
	}

//	hx = random(144);
//	hy = random(68);
//	hy += 16;
	
	// Buffers for grayscale
	char *lightbuff = malloc(LCD_SIZE);
	char *darkbuff = malloc(LCD_SIZE);
	char *lightdisp = malloc(LCD_SIZE);
	char *darkdisp = malloc(LCD_SIZE);

	clearbuffs(lightbuff, darkbuff);
	clearbuffs(lightdisp, darkdisp);
	
	drawbackground(lightbuff, darkbuff);

/////////////////////////////////////////////////////////////// intro screen //////////////////////////////////////
titlescreen(GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
    
	while (!_keytest(RR_ENTER) && !_keytest(RR_ESC) && !_keytest(RR_2ND))
		{
		if (_keytest(RR_PLUS))
			{
			OSContrastUp();
			while (_keytest(RR_PLUS)){}
			}
		if (_keytest(RR_MINUS))
			{
			OSContrastDn();
			while (_keytest(RR_MINUS)){}
			}
		}
	while (_keytest(RR_ENTER) || _keytest(RR_ESC) || _keytest(RR_2ND)){}
///////////////////////////////////////////////////// end of the intro screen //////////////////////////////////////
/////////////////////////////////////////////////////////// menu screen ////////////////////////////////////////////
	clear_gray_screen();
	
	copybuffs(lightbuff, darkbuff, lightdisp, darkdisp);
	graymasksprite16 (x, y, 32, peter_right, lightdisp, darkdisp);
	graymasksprite16 (gx, gy, 32, gguy1, lightdisp, darkdisp);
	copybuffs(lightdisp, darkdisp, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));

for (loop = 0; loop < 2; loop++)
	{
	if (loop == 1)
		SetPlane (LIGHT_PLANE);
	if (loop == 2)
		SetPlane (DARK_PLANE);
	FontSetSys (F_6x8);
	printf_xy (11,11,"Start Game");
	printf_xy (11,22,"Clear Score");
	printf_xy (11,33,"dificulty %i", dificulty);
	printf_xy (11,44,"Quit");
	FontSetSys (F_8x10);
	printf_xy (1,80,"fastest time: %i", oldscore);
	}

Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);

for (loop2 = 0; loop2 < 1000; loop2++){caught += .1;}
while (!start && !ext)
	{
	if (_keytest(RR_2ND) && select == 11) start = 1;
	if (_keytest(RR_PLUS))
		{
		OSContrastUp();
		while (_keytest(RR_PLUS)){}
		}
	if (_keytest(RR_MINUS))
		{
		OSContrastDn();
		while (_keytest(RR_MINUS)){}
		}

	if (select != 11)
		{
		if (_keytest(RR_UP))
			{
			for (loop = 0; loop < 11; loop++)
				{
				Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
				Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);
				select -= 1;
				Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
				Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);
				for (loop2 = 0; loop2 < 5; loop2++)
					{
					for (loop3 = 0; loop3 < 30000; loop3++){}
					}
				}
			}
		}
	if (select != 44)
		{
		if (_keytest(RR_DOWN))
			{
			for (loop = 0; loop < 11; loop++)
				{
				Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
				Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);
				select += 1;
				Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
				Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);
				for (loop2 = 0; loop2 < 5; loop2++)
					{
					for (loop3 = 0; loop3 < 30000; loop3++){}
					}
				}
			}
		}
	if (_keytest(RR_ESC)) ext = 1;
	if (select == 22 && _keytest(RR_2ND))
		{
		if(!(sym->flags.bits.archived))		
			{
			FILE *fp = fopen ("catchhsc", "wb");
			fwrite(&foo,sizeof(int),1,fp);
			fputc (0, fp);
			fputs ("hisc", fp);
			fputc (0, fp);
			fputc (OTH_TAG, fp);
			fclose (fp);
			SetPlane (LIGHT_PLANE);
			printf_xy (1,80,"fastest time: 9999");
			SetPlane (DARK_PLANE);
			printf_xy (1,80,"fastest time: 9999");
			oldscore = foo;
			while (_keytest(RR_2ND)){}
			}
		}
	if (select == 33 && _keytest(RR_2ND))
		{
		dificulty++;
		if (dificulty > 9) dificulty = 1;
		SetPlane (LIGHT_PLANE);
		printf_xy (11,33,"dificulty %i", dificulty);
		SetPlane (DARK_PLANE);
		printf_xy (11,33,"dificulty %i", dificulty);
		while (_keytest(RR_2ND)){}
		}
	if (select == 44 && _keytest(RR_2ND)) ext = 1;
	}
if (!ext)
{
	clear_gray_screen();
	
	//graysprite16 (x, y, 32, peter, lightbuff, darkbuff);
	//graysprite16 (gx, gy, 32, guy1, lightbuff, darkbuff);
	//dispgraybuffs(lightbuff, darkbuff);
	// F_4x6, F_6x8, and F_8x10
	for (loop = 3; loop > 0; loop--)
		{
		for (loop3 = 1; loop3 <= 3; loop3++)
			{
			copybuffs(lightdisp, darkdisp, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
			if (loop3 == 1) FontSetSys (F_8x10);
			if (loop3 == 2) FontSetSys (F_6x8);
			if (loop3 == 3) FontSetSys (F_4x6);
			
			printf_xy (72, 42,"%i",loop);
			
			for (caught = 0; caught < 800; caught++){}
			
			//while (caught < 100)
			//	{
			//	caught += .1;
			//	}
			}
		}
}
			caught = 0;

	
	while (!_keytest(RR_ESC) && caught <= 30 && !ext)
		{
		if (jump > 0)
			jump--;
		
/*		if (_keytest(RR_SHIFT))
			{
			trp = 1;
			trpx = x;
			trpy = y+32;
			}
		if (trp)
			graymasksprite16 (trpx, trpy, 13, trap, lightdisp, darkdisp);
*/			
		if (_keytest(RR_PLUS))
			{
			OSContrastUp();
			while (_keytest(RR_PLUS)){}
			}
		if (_keytest(RR_MINUS))
			{
			OSContrastDn();
			while (_keytest(RR_MINUS)){}
			}
		
		//clearbuffs(lightbuff, darkbuff);
		
		time ++;
		
		if (_keytest (RR_LEFT) && x > 1)	x-=2;
		if (_keytest (RR_RIGHT) && x < 143)	x+=2;
		if (_keytest (RR_UP) && y > 1)		y-=2;
		if (_keytest (RR_DOWN) && y < 67)	y+=2;
		
		if (_keytest(RR_RIGHT)) lr = 1;
		if (_keytest(RR_LEFT)) lr = 2;

		change++;
		
		if (change == 15){
		if (guy == 1){guy = 2;} else {guy = 1;}
		change = 1;}
		
		if ((gx - x) < 45)
			if (gx < 140 && x < gx) gx++;
		if ((x - gx) < 45)
			if (gx > 6 && x > gx) gx--;
		if ((gy - y) < 45)
			if (gy < 62 && y < gy) gy++;
		if ((y - gy) < 45)
			if (gy > 6 && y > gy) gy--;

//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
		if (_keytest(RR_2ND) && jump == 0)
			{
			jump = dificulty*15;
			if (x > 128)
				x = 128;
			if (x < 16)
				x = 16;
			if (lr == 1) graymasksprite32 (x, y, 32, dive_right1, lightdisp, darkdisp);
			if (lr == 2) graymasksprite32 (x-16, y, 32, dive_left1, lightdisp, darkdisp);
			
			graymasksprite16 (gx, gy, 32, gguy1, lightdisp, darkdisp);
			copybuffs(lightdisp, darkdisp, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
			copybuffs(lightbuff, darkbuff, lightdisp, darkdisp);
			y += 15;
			for (loop2 = 0; loop2 < 75; loop2++)
				{
				for (loop3 = 0; loop3 < 30000; loop3++){}
				}
			for (loop = 0; loop < 5; loop ++)
				{
				graymasksprite16 (gx, gy, 32, gguy1, lightdisp, darkdisp);
				if (lr == 1)
					{
					if (x < 127)
						x += 2;
					graymasksprite32 (x, y, 16, dive_right, lightdisp, darkdisp);
					}
				if (lr == 2)
					{
					if (x > 17)
						x -= 2;
					graymasksprite32 (x-16, y, 16, dive_left, lightdisp, darkdisp);
					}
				y -= 1;
				
				if ((gx - x) < 45)
					if (gx < 140 && x < gx) gx++;
				if ((x - gx) < 45)
					if (gx > 6 && x > gx) gx--;
				if ((gy - (y-15)) < 45)
					if (gy < 62 && (y-15) < gy) gy++;
				if (((y-15) - gy) < 45)
					if (gy > 6 && (y-15) > gy) gy--;
				
				copybuffs(lightdisp, darkdisp, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
				copybuffs(lightbuff, darkbuff, lightdisp, darkdisp);
				for (loop2 = 0; loop2 < 15; loop2++)
					{
					for (loop3 = 0; loop3 < 30000; loop3++){}
					}
				}
			for (loop = 0; loop < 5; loop ++)
				{
				graymasksprite16 (gx, gy, 32, gguy1, lightdisp, darkdisp);
				if (lr == 1)
					{
					if (x < 127)
						x += 2;
					graymasksprite32 (x, y, 16, dive_right, lightdisp, darkdisp);
					}
				if (lr == 2)
					{
					if (x > 17)
						x -= 2;
					graymasksprite32 (x-16, y, 16, dive_left, lightdisp, darkdisp);
					}
				y += 1;
				
				if ((gx - x) < 45)
					if (gx < 140 && x < gx) gx++;
				if ((x - gx) < 45)
					if (gx > 6 && x > gx) gx--;
				if ((gy - (y-15)) < 45)
					if (gy < 62 && (y-15) < gy) gy++;
				if (((y-15) - gy) < 45)
					if (gy > 6 && (y-15) > gy) gy--;
				
				copybuffs(lightdisp, darkdisp, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
				copybuffs(lightbuff, darkbuff, lightdisp, darkdisp);
				for (loop2 = 0; loop2 < 15; loop2++)
					{
					for (loop3 = 0; loop3 < 30000; loop3++){}
					}
				}
			y -= 15;
			
		//////////////////////////////////////// GRAB HIM ////////////////////////////////////////////
			//if (x > (gx-5) && x < (gx+5) && y > (gy-5) && y < (gy+5)) //&& _keytest(RR_2ND)) 
			//if (x > gx && x < (gx+32) && y > (gy-7) && y < (gy+7)) //&& _keytest(RR_2ND)) 
			if (lr == 2)
				{
				if ((x-16) > gx && (x-16) < (gx+16) && (y+23) > (gy+16) && (y+23) < (gy+32)) //&& _keytest(RR_2ND)) 
					snag = 1;
				}
			if (lr == 1)
				{
				if ((x+32) > gx && (x+32) < (gx+16) && (y+23) > (gy+16) && (y+23) < (gy+32)) //&& _keytest(RR_2ND)) 
					snag = 1;
				}
			
			if (snag)
				{
				snag = 0;
				if (lr == 1)
					{
					x -= 1;
					} else {
					x -= 16;
					x += 1;
					}
				
				if (x > 128)
					x = 128;
				key = 1;
				caught = 15;
				for(loop = 0; loop < 3000 && caught < 31 && caught > 0; loop++)
					{
					time++;
					if (_keytest(RR_RIGHT) && !_keytest(RR_LEFT) && key == 1 && !_keytest(RR_2ND))
						{
						key = 2;
						caught ++;
						}
					if (!_keytest(RR_RIGHT) && _keytest(RR_LEFT) && key == 2 && !_keytest(RR_2ND))
						{
						key = 1;
						caught ++;
						}
					
					if (caught > 0) caught -= (.02 * dificulty);
					
					DrawLineFast (0, 99, (int)(caught * (160/30)), 99, darkdisp);
					DrawLineFast (0, 98, (int)(caught * (160/30)), 98, darkdisp);
					DrawLineFast (0, 97, (int)(caught * (160/30)), 97, darkdisp);
					DrawLineFast (0, 96, (int)(caught * (160/30)), 96, darkdisp);
					//for (loop2 = 0; loop2 < (dificulty *100); loop2++){}
					
					if (lr == 1)
						graymasksprite32 (x, y, 32, caught_right, lightdisp, darkdisp);
					if (lr == 2)
						graymasksprite32 (x, y, 32, caught_left, lightdisp, darkdisp);
				
					if (key == 1)
						graymasksprite16 (72, 42, 15, rarrow, lightdisp, darkdisp);
					if (key == 2)
						graymasksprite16 (72, 42, 15, larrow, lightdisp, darkdisp);
				
					copybuffs(lightdisp, darkdisp, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
					copybuffs(lightbuff, darkbuff, lightdisp, darkdisp);
					}
				}
			}
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
				
		if (y >= gy)
			{
			if (guy == 1)
				graymasksprite16 (gx, gy, 32, gguy1, lightdisp, darkdisp);
			if (guy == 2)
				graymasksprite16 (gx, gy, 32, gguy2, lightdisp, darkdisp);
			if (lr == 1)
				graymasksprite16 (x, y, 32, peter_right, lightdisp, darkdisp);
			if (lr == 2)
				graymasksprite16 (x, y, 32, peter_left, lightdisp, darkdisp);
			} else {
			if (lr == 1)
				graymasksprite16 (x, y, 32, peter_right, lightdisp, darkdisp);
			if (lr == 2)
				graymasksprite16 (x, y, 32, peter_left, lightdisp, darkdisp);
			if (guy == 1)
				graymasksprite16 (gx, gy, 32, gguy1, lightdisp, darkdisp);
			if (guy == 2)
				graymasksprite16 (gx, gy, 32, gguy2, lightdisp, darkdisp);
			}
		
		copybuffs(lightdisp, darkdisp, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
		copybuffs(lightbuff, darkbuff, lightdisp, darkdisp);
		}
		
	time = (time + ((10 - dificulty)*100));

	if (caught >= 30)
		{
		copybuffs(lightdisp, darkdisp, GetPlane(LIGHT_PLANE), GetPlane(DARK_PLANE));
		Sprite32 (80-32, 43, 14, cau, GrayGetPlane (LIGHT_PLANE), SPRT_OR);
		Sprite32 (80-32, 43, 14, cau, GrayGetPlane (DARK_PLANE), SPRT_OR);
		Sprite32 (80, 43, 14, ght, GrayGetPlane (LIGHT_PLANE), SPRT_OR);
		Sprite32 (80, 43, 14, ght, GrayGetPlane (DARK_PLANE), SPRT_OR);
		MoveTo(0,0); printf("Time: %i",time);
		
		if (time < oldscore)
			{
			if(!(sym->flags.bits.archived))		
				{
				FILE *fp = fopen ("catchhsc", "wb");
				fwrite(&time,sizeof(int),1,fp);
				fputc (0, fp);
				fputs ("hisc", fp);
				fputc (0, fp);
				fputc (OTH_TAG, fp);
				fclose (fp);
				}
			printf_xy (0,0,"Time: %i FASTEST TIME!",time);
			}
		while (!_keytest(RR_ESC) && !_keytest(RR_2ND)){};
		GrayOff ();
		SetIntVec (AUTO_INT_1, save_int_1);
		SetIntVec (AUTO_INT_5, save_int_5);
		LCD_restore(scrBuf);
		free(scrBuf);
		free(lightbuff);							// free alocation
		free(darkbuff);								// free alocation
		free(lightdisp);							// free alocation
		free(darkdisp);								// free alocation
		ST_helpMsg("By Alex Clink    ");
		} else {		
		GrayOff ();
		SetIntVec (AUTO_INT_1, save_int_1);
		SetIntVec (AUTO_INT_5, save_int_5);
		LCD_restore(scrBuf);
		free(scrBuf);
		free(lightbuff);							// free alocation
		free(darkbuff);								// free alocation
		free(lightdisp);							// free alocation
		free(darkdisp);								// free alocation
		ST_helpMsg("yo neva gona catch me yo wastin yo time");
		}
}
/* no comment */

