//#define SAVE_SCREEN				// this directive forces saving/restoring the screen

// produce all types of files
#define USE_TI89				// 89
#define USE_TI92PLUS			// 92+
#define USE_V200				// voyage 200

#include <stdio.h>				// standard ANSI C input/output support
#include <kbd.h>				// keyboard handling support, needed for ngetchx
#include <tigcclib.h>			// include all headers
#include "data & functions.h"

void _main(void)							// main entrie point of program
{
int oldscore;
int foo = 9999;
FILE *catchhsc;

// obtain the location of the file
//SYM_ENTRY *sym=SymFindPtr(SYMSTR("catchhsc"),0);
//HANDLE h=sym->handle;

/////////////////////////////// read file "catcghsc" /////////////////////////////////////
/**/				SYM_ENTRY *sym=SymFindPtr(SYMSTR("catchhsc"),0);
/**/				HANDLE h=sym->handle;
/**/				void *ptr=HeapDeref(h);
/**/				if (!(oldscore=*(int*)(ptr+2))) /*handle error*/;
//////////////////////////////////////////////////////////////////////////////////////////
if (oldscore < 1 || oldscore > 9999)
	{
	if(!(sym->flags.bits.archived))		
		{
		FILE *fp = fopen ("catchhsc", "wb");
		fwrite(&foo,sizeof(int),1,fp);
		fputc (0, fp);
		fputs ("hisc", fp);
		fputc (0, fp);
		fputc (OTH_TAG, fp);
		fclose (fp);
		oldscore = foo;
		}
	}


void *scrBuf=malloc(LCD_SIZE);
LCD_save(scrBuf);
randomize();
	
int x,y,quit,gx,gy,guy,change,lr,key,time,loop2,loop3,ext,select;
x = random(144);
y = random(68);
gx = random(144);
gy = random(60);
change = guy = 1;
lr = 1;
time = ext = 0;
float caught = 0;
select = 11;
int dificulty = 1;
int start = 0;

if (sym->flags.bits.archived)
	{
	clear_gray_screen();
	FontSetSys (F_8x10);	
	printf_xy (30,1,"**WARNING**");
	FontSetSys (F_6x8);
	printf_xy (0,20,"I won't be able to save");
	printf_xy (0,30,"please unarchive catchhsc");
	while (!_keytest(RR_ENTER) && !_keytest(RR_2ND) && !_keytest(RR_ESC)){};
	}

//	hx = random(144);
//	hy = random(68);
//	hy += 16;
	
	// Buffers for grayscale
	char *lightBuff = malloc(LCD_SIZE);
	char *darkBuff = malloc(LCD_SIZE);

	clearbuffs(lightBuff, darkBuff);

/////////////////////////////////////////////////////////////// intro screen //////////////////////////////////////
    unsigned char* plane1;
    unsigned char* plane2;
    unsigned char* dest1;
    unsigned char* dest2;
    unsigned char* src1;
    unsigned char* src2;
    int            loop;
    
INT_HANDLER save_int_1;
save_int_1 = GetIntVec (AUTO_INT_1);
SetIntVec (AUTO_INT_1, DUMMY_HANDLER);
INT_HANDLER save_int_5;
save_int_5 = GetIntVec (AUTO_INT_5);
SetIntVec (AUTO_INT_5, DUMMY_HANDLER);

	if (!GrayOn())
		{
		SetIntVec (AUTO_INT_1, save_int_1);
		SetIntVec (AUTO_INT_5, save_int_5);
		return;
		}

    plane1 = GetPlane(0);
    plane2 = GetPlane(1);

    dest1 = plane1;
    dest2 = plane2;
    src1  = layer1;
    src2  = layer2;

    if (!TI89) {
        memset(plane1,0,LCD_SIZE);
        memset(plane2,0,LCD_SIZE);

        dest1 += ((128-100)*30)/2 + ((240-160)/8)/2;
        dest2 += ((128-100)*30)/2 + ((240-160)/8)/2;
    }

    for (loop=0;loop<100;loop++,src1+=20,src2+=20,dest1+=30,dest2+=30) {
        memcpy(dest1,src1,20);
        memcpy(dest2,src2,20);
    }
    
	while (!_keytest(RR_ENTER) && !_keytest(RR_ESC) && !_keytest(RR_2ND))
		{
		if (_keytest(RR_PLUS))
			{
			OSContrastUp();
			for (loop = 0; loop < 10000; loop++){}	// delay
			}
		if (_keytest(RR_MINUS))
			{
			OSContrastDn();
			for (loop = 0; loop < 10000; loop++){}	// delay
			}
		}
	
///////////////////////////////////////////////////// end of the intro screen //////////////////////////////////////
///////////////////////////////////////////////////// end of the intro screen //////////////////////////////////////
	clear_gray_screen();

	graysprite16 (x, y, 32, peter, lightBuff, darkBuff);
	graysprite16 (gx, gy, 32, guy1, lightBuff, darkBuff);
	dispgraybuffs(lightBuff, darkBuff);

FontSetSys (F_6x8);
printf_xy (11,11,"Start Game");
printf_xy (11,22,"Clear Score");
printf_xy (11,33,"dificulty %i", dificulty);
printf_xy (11,44,"Quit");
FontSetSys (F_8x10);
printf_xy (1,80,"fastest time: %i", oldscore);

Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);

for (loop2 = 0; loop2 < 1000; loop2++){caught += .1;}
while (!start && !ext)
	{
	if (_keytest(RR_2ND) && select == 11) start = 1;
	if (_keytest(RR_PLUS))
		{
		OSContrastUp();
		for (loop = 0; loop < 10000; loop++){}	// delay
		}
	if (_keytest(RR_MINUS))
		{
		OSContrastDn();
		for (loop = 0; loop < 10000; loop++){}	// delay
		}

	if (select != 11)
		{
		if (_keytest(RR_UP))
			{
			for (loop = 0; loop < 11; loop++)
				{
				Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
				Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);
				select -= 1;
				Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
				Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);
					for (loop2 = 0; loop2 < 5000; loop2++){}
				}
			}
		}
	if (select != 44)
		{
		if (_keytest(RR_DOWN))
			{
			for (loop = 0; loop < 11; loop++)
				{
				Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
				Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);
				select += 1;
				Sprite8(1, select, 8, curser, GetPlane(LIGHT_PLANE), SPRT_XOR);
				Sprite8(1, select, 8, curser, GetPlane(DARK_PLANE), SPRT_XOR);
					for (loop2 = 0; loop2 < 5000; loop2++){}
				}
			}
		}
	if (_keytest(RR_ESC)) ext = 1;
	if (select == 22 && _keytest(RR_2ND))
		{
		if(!(sym->flags.bits.archived))		
			{
			FILE *fp = fopen ("catchhsc", "wb");
			fwrite(&foo,sizeof(int),1,fp);
			fputc (0, fp);
			fputs ("hisc", fp);
			fputc (0, fp);
			fputc (OTH_TAG, fp);
			fclose (fp);
			printf_xy (1,80,"fastest time: 9999");
			oldscore = foo;
			for (loop2 = 0; loop2 < 30000; loop2++) {}
			}
		}
	if (select == 33 && _keytest(RR_2ND))
		{
		dificulty++;
		if (dificulty > 5) dificulty = 1;
		printf_xy (11,33,"dificulty %i", dificulty);
		for (loop2 = 0; loop2 < 30000; loop2++) {}
		}
	if (select == 44 && _keytest(RR_2ND)) ext = 1;
	}
if (!ext)
{
	clear_gray_screen();
	
	graysprite16 (x, y, 32, peter, lightBuff, darkBuff);
	graysprite16 (gx, gy, 32, guy1, lightBuff, darkBuff);
	dispgraybuffs(lightBuff, darkBuff);
	// F_4x6, F_6x8, and F_8x10
	for (loop = 3; loop > 0; loop--)
		{
		for (loop3 = 1; loop3 <= 3; loop3++)
			{
			MoveTo(72, 42);
			
			if (loop3 == 1) FontSetSys (F_8x10);
			if (loop3 == 2) FontSetSys (F_6x8);
			if (loop3 == 3) FontSetSys (F_4x6);
			
			printf ("%i",loop);
			for (loop2 = 0; loop2 < 1000; loop2++) {caught += .1;}
			dispgraybuffs(lightBuff, darkBuff);
			}
		}
}
	caught = 0;
	while (!_keytest(RR_ESC) && caught <= 30 && !ext)
		{
		if (_keytest(RR_PLUS))
			{
			OSContrastUp();
			for (loop = 0; loop < 10000; loop++){}	// delay
			}
		if (_keytest(RR_MINUS))
			{
			OSContrastDn();
			for (loop = 0; loop < 10000; loop++){}	// delay
			}
		
		clearbuffs(lightBuff, darkBuff);
		
		time ++;
		
		if (_keytest (RR_LEFT) && x > 1)	x-=2;
		if (_keytest (RR_RIGHT) && x < 143)	x+=2;
		if (_keytest (RR_UP) && y > 1)		y-=2;
		if (_keytest (RR_DOWN) && y < 67)	y+=2;
		
		if (_keytest(RR_RIGHT)) lr = 1;
		if (_keytest(RR_LEFT)) lr = 2;

		change++;
		
		if (change == 15){
		if (guy == 1){guy = 2;} else {guy = 1;}
		change = 1;}
		
		if ((gx - x) < 45)
			if (gx < 140 && x < gx) gx++;
		if ((x - gx) < 45)
			if (gx > 6 && x > gx) gx--;
		if ((gy - y) < 45)
			if (gy < 62 && y < gy) gy++;
		if ((y - gy) < 45)
			if (gy > 6 && y > gy) gy--;
		
		if (guy == 1)
			graysprite16 (gx, gy, 32, guy1, lightBuff, darkBuff);
		if (guy == 2)
			graysprite16 (gx, gy, 32, guy2, lightBuff, darkBuff);
		
		if (lr == 1)
			graysprite16 (x, y, 32, peter, lightBuff, darkBuff);
		if (lr == 2)
			graysprite16 (x, y, 32, peter1, lightBuff, darkBuff);

		dispgraybuffs(lightBuff, darkBuff);
		
		for (loop = 0; loop < 2000; loop++) {}
		// GRAB HIM!!!!!!!!!!!! //////////////////////////////////////////////////////
		if (x > (gx-5) && x < (gx+5) && y > (gy-5) && y < (gy+5) && _keytest(RR_2ND)) 
			{
			time++;
			clearbuffs(lightBuff, darkBuff);
			
			graysprite32 (x, y, 32, grab, lightBuff, darkBuff);
			
			key = 1;
			caught = 0;
			
			dispgraybuffs(lightBuff, darkBuff);
		
			graysprite16 (72, 42, 16, rarrow,  GrayGetPlane (LIGHT_PLANE),  GrayGetPlane (DARK_PLANE));
			
			for(loop = 0; loop < 2350 && caught < 30; loop++)
				{
				if (_keytest(RR_RIGHT) && !_keytest(RR_LEFT) && key == 1 && !_keytest(RR_2ND))
					{
					dispgraybuffs(lightBuff, darkBuff);
					graysprite16 (72, 42, 16, larrow,  GrayGetPlane (LIGHT_PLANE),  GrayGetPlane (DARK_PLANE));
					key = 2;
					caught ++;
					}
				if (!_keytest(RR_RIGHT) && _keytest(RR_LEFT) && key == 2 && !_keytest(RR_2ND))
					{
					dispgraybuffs(lightBuff, darkBuff);
					graysprite16 (72, 42, 16, rarrow,  GrayGetPlane (LIGHT_PLANE),  GrayGetPlane (DARK_PLANE));
					key = 1;
					caught ++;
					}
//				ipart = caught * (160/25);
				if (caught > 0) caught -= .05;
				DrawLine (0, 99, 160, 99, 0);
				DrawLine (0, 99, (int)(caught * (160/30)), 99, 1);
				DrawLine (0, 98, 160, 98, 0);
				DrawLine (0, 98, (int)(caught * (160/30)), 98, 1);
				DrawLine (0, 97, 160, 97, 0);
				DrawLine (0, 97, (int)(caught * (160/30)), 97, 1);
				DrawLine (0, 96, 160, 96, 0);
				DrawLine (0, 96, (int)(caught * (160/30)), 96, 1);
				for (loop2 = 0; loop2 < (dificulty *100); loop2++){}
				}
			}
		}
		time += (dificulty *10);
	if (caught >= 30)
		{
		dispgraybuffs(lightBuff, darkBuff);
		Sprite32 (80-32, 43, 14, cau, GrayGetPlane (LIGHT_PLANE), SPRT_OR);
		Sprite32 (80-32, 43, 14, cau, GrayGetPlane (DARK_PLANE), SPRT_OR);
		Sprite32 (80, 43, 14, ght, GrayGetPlane (LIGHT_PLANE), SPRT_OR);
		Sprite32 (80, 43, 14, ght, GrayGetPlane (DARK_PLANE), SPRT_OR);
		MoveTo(0,0); printf("Time: %i",time);
		
		if (time < oldscore)
			{
			if(!(sym->flags.bits.archived))		
				{
				FILE *fp = fopen ("catchhsc", "wb");
				fwrite(&time,sizeof(int),1,fp);
				fputc (0, fp);
				fputs ("hisc", fp);
				fputc (0, fp);
				fputc (OTH_TAG, fp);
				fclose (fp);
				}
			printf_xy (0,0,"Time: %i FASTEST TIME!",time);
			}
		while (!_keytest(RR_ESC) && !_keytest(RR_2ND)){};
		GrayOff ();
		SetIntVec (AUTO_INT_1, save_int_1);
		SetIntVec (AUTO_INT_5, save_int_5);
		LCD_restore(scrBuf);
		free(scrBuf);
		free(lightBuff);							// free alocation
		free(darkBuff);								// free alocation
		ST_helpMsg("By Alex Clink    ");
		} else {		
		GrayOff ();
		SetIntVec (AUTO_INT_1, save_int_1);
		SetIntVec (AUTO_INT_5, save_int_5);
		LCD_restore(scrBuf);
		free(scrBuf);
		free(lightBuff);							// free alocation
		free(darkBuff);								// free alocation
		ST_helpMsg("yo neva gona catch me yo wastin yo time");
		}
}
/* no comment */

